from typing import List
from pydantic import BaseModel


class SubsriberConfig(BaseModel):
    name: str
    persistence: bool
    topic: str
    publish_key: str
    subscribe_key: str


class Subscriber(BaseModel):
    id: str
    type: str
    subtype: str
    config: SubsriberConfig
    on_message: str
    retry: int


class PublisherConfig(BaseModel):
    name: str
    db: int
    endpoint: str
    queue: str
    worker: str
    job: str


class Publisher(BaseModel):
    direction: str
    type: str
    subtype: str
    config: PublisherConfig


class PostmasterSubscribers(BaseModel):
    subscribers: List[Subscriber]
    publishers: List[Publisher]
