from typing import Any
from pydantic import BaseModel


class Metadata(BaseModel):
    name: str
    namespace: str | None
    annotations: Any | None
    creationTimestamp: Any | None
    finalizers: Any | None
    generation: int | None
    labels: Any | None
    managedFields: Any | None
    resourceVersion: str | None
    uid: str | None


class CRDBase(BaseModel):
    apiVersion: str
    kind: str
    metadata: Metadata
